#ifndef MSP_GRAPHICS_WINDOW_PLATFORM_H_
#define MSP_GRAPHICS_WINDOW_PLATFORM_H_

#include <android/input.h>
#include <android/native_window.h>

namespace Msp {
namespace Graphics {

typedef ANativeWindow *WindowHandle;

enum AndroidEventType
{
	INPUT_EVENT,
	WINDOW_CREATED,
	WINDOW_RESIZED,
	WINDOW_DESTROYED
};

struct PlatformWindowPrivate
{
	mutable sigc::signal<void, WindowHandle> signal_window_acquired;
	mutable sigc::signal<void> signal_window_lost;
};

struct PlatformEvent
{
	AndroidEventType type;
	AInputEvent *aevent;
};

} // namespace Graphics
} // namespace Msp

#endif
