#include <msp/strings/format.h>
#include "videomode.h"

namespace Msp {
namespace Graphics {

unsupported_video_mode::unsupported_video_mode(const VideoMode &mode):
	runtime_error(format("%dx%d", mode.width, mode.height))
{ }


VideoMode::VideoMode():
	index(0),
	monitor(0),
	width(0),
	height(0),
	rate(0),
	rotation(ROTATE_ANY)
{ }

VideoMode::VideoMode(unsigned w, unsigned h):
	index(0),
	monitor(0),
	width(w),
	height(h),
	rate(0),
	rotation(ROTATE_ANY)
{ }

} // namespace Graphics
} // namespace Msp
